
package de.ivu.elect.presentation.stimmzettel.menu;

import java.util.Collections;
import java.util.List;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.presentation.menu.AbstractMenuItemEntry;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;
import de.ivu.elect.presentation.stimmzettel.StimmzettelErfassungVerfuegbar;
import de.ivu.elect.presentation.stimmzettel.StimmzettelSearchView;

@Named(StimmzettelSearchMenuItemEntry.COMPONENT_NAME)
public class StimmzettelSearchMenuItemEntry extends AbstractMenuItemEntry {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "stimmzettelSearchMenuItemEntry";

  @Inject
  private transient StimmzettelErfassungVerfuegbar stimmzettelErfassungVerfuegbar;

  @Override
  public boolean isRendered() {
    return hasUseCasePermission(UseCasePermission.STIMMZETTEL_SEARCH);
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return getEinsehenGebietSecurity();
  }

  @Override
  public boolean isDisabledInternal() {
    return !stimmzettelErfassungVerfuegbar.isStimmzettelErfassungVerfuegbar();
  }

  @Override
  public String getTargetViewId() {
    return StimmzettelSearchView.VIEW_ID;
  }


  @Override
  protected String getLabel() {
    return getMessage(getLabelKey());
  }

  @Override
  public String getLabelKey() {
    return "stimmzettel.erfassen.menu.entry.label";
  }

  @Override
  public String getIcon() {
    return getIcons().getIconSearch();
  }

  @Override
  protected List<String> getAdditionalTopicViewIds() {
    return Collections.emptyList();
  }
}
